;
;*******************************************************
;*******************************************************
;**                                                   **
;**    Sztuka programowania mikrokontrolerow AVR      **
;**                  Drugi program                    **
;**                 wariant pierwszy                  **
;**                                                   **
;**       Andrzej Pawluczuk                           **
;**                                                   **
;**         Mikrokontroler: ATMEGA8515                **
;**                Bialystok, 2006                    **
;**                                                   **
;*******************************************************
;*******************************************************
;
	.nolist
;*******************************************************
.include "m8515def.inc"
;*******************************************************
	.list
;---------------------------------------------------------------
.def acc		= r16
.def acc2		= r17
;---------------------------------------------------------------
	.cseg
;---------------------------------------------------------------
	.org	0		;
	rjmp	ResetProcessor	;
;---------------------------------------------------------------
EnvirInit :			;
	ldi	acc,0b00000000	;
	out	DDRA,acc	;
	ldi	acc,0b11111111	;
	out	PORTA,acc	;
	ldi	acc,0b11111111	;
	out	DDRB,acc	;
	ldi	acc,0b11111111	;
	out	PORTB,acc	;
	ret			;
;---------------------------------------------------------------
ResetProcessor :		;
	ldi	acc,HIGH(RAMEND);
	out	SPH,acc		;
	ldi	acc,LOW(RAMEND) ;
	out	SPL,acc		;
;---------------------------------------------------------------
Main	:			;
	rcall	EnvirInit	;
	ldi	acc,0b11111110	; PORTB := 0B11111110 ;
	out	PortB,acc	;
Main_0	:			;
	in	acc,PINA	;
	mov	acc2,acc	;
	andi	acc,0x01	;  jeeli PORTA bit 0 = 0 to
	brne	Main_10		;
	ldi	acc,0b11111110	;    PORTB := 0B11111110 ;
	out	PortB,acc	;
	rjmp	Main_0		;
Main_10	:			;
	mov	acc,acc2	;
	andi	acc,0x02	;
	brne	Main_11		;
	ldi	acc,0b11111101	;
	out	PortB,acc	;
	rjmp	Main_0		;
Main_11	:			;
	mov	acc,acc2	;
	andi	acc,0x04	;
	brne	Main_12		;
	ldi	acc,0b11111011	;
	out	PortB,acc	;
	rjmp	Main_0		;
Main_12	:			;
	mov	acc,acc2	;
	andi	acc,0x08	;
	brne	Main_13		;
	ldi	acc,0b11110111	;
	out	PortB,acc	;
	rjmp	Main_0		;
Main_13	:			;
	mov	acc,acc2	;
	andi	acc,0x10	;
	brne	Main_14		;
	ldi	acc,0b11101111	;
	out	PortB,acc	;
	rjmp	Main_0		;
Main_14	:			;
	mov	acc,acc2	;
	andi	acc,0x20	;
	brne	Main_15		;
	ldi	acc,0b11011111	;
	out	PortB,acc	;
	rjmp	Main_0		;
Main_15	:			;
	mov	acc,acc2	;
	andi	acc,0x40	;
	brne	Main_16		;
	ldi	acc,0b10111111	;
	out	PortB,acc	;
	rjmp	Main_0		;
Main_16	:			;
	mov	acc,acc2	;
	andi	acc,0x80	;
	brne	Main_17		;
	ldi	acc,0b01111111	;
	out	PortB,acc	;
	rjmp	Main_0		;
Main_17	:			;
	rjmp	Main_0		;
;---------------------------------------------------------------
.exit
