;
;*******************************************************
;*******************************************************
;**                                                   **
;**    Sztuka programowania mikrokontrolerow AVR      **
;**                  Drugi program                    **
;**                  wariant drugi                    **
;**                                                   **
;**       Andrzej Pawluczuk                           **
;**                                                   **
;**         Mikrokontroler: ATMEGA8515                **
;**                Bialystok, 2006                    **
;**                                                   **
;*******************************************************
;*******************************************************
;
	.nolist
;*******************************************************
.include "m8515def.inc"
;*******************************************************
	.list
;---------------------------------------------------------------
.def acc	= r16
;---------------------------------------------------------------
	.cseg
;---------------------------------------------------------------
	.org	0		;
	rjmp	ResetProcessor	;
;---------------------------------------------------------------
EnvirInit :			;
	ldi	acc,0b00000000	;
	out	DDRA,acc	;
	ldi	acc,0b11111111	;
	out	PORTA,acc	;
	ldi	acc,0b11111111	;
	out	DDRB,acc	;
	ldi	acc,0b11111111	;
	out	PORTB,acc	;
	ret			;
;---------------------------------------------------------------
ResetProcessor :		;
	ldi	acc,HIGH(RAMEND);
	out	SPH,acc		;
	ldi	acc,LOW(RAMEND) ;
	out	SPL,acc		;
;---------------------------------------------------------------
Main	:			;
	rcall	EnvirInit	;
	ldi	acc,0b11111110	; PORTB := 0B11111110 ;
	out	PortB,acc	;
Main_0	:			;
	sbis	PINA,0		; badanie bitu o numerze 0 w porcie A
	rjmp	Main_10		; warunkowe opuszczenie instrukcji
	sbis	PINA,1		; badanie bitu o numerze 1 w porcie A
	rjmp	Main_11		; warunkowe opuszczenie instrukcji
	sbis	PINA,2		; badanie bitu o numerze 2 w porcie A
	rjmp	Main_12		; warunkowe opuszczenie instrukcji
	sbis	PINA,3		; badanie bitu o numerze 3 w porcie A
	rjmp	Main_13		; warunkowe opuszczenie instrukcji
	sbis	PINA,4		; badanie bitu o numerze 4 w porcie A
	rjmp	Main_14		; warunkowe opuszczenie instrukcji
	sbis	PINA,5		; badanie bitu o numerze 5 w porcie A
	rjmp	Main_15		; warunkowe opuszczenie instrukcji
	sbis	PINA,6		; badanie bitu o numerze 6 w porcie A
	rjmp	Main_16		; warunkowe opuszczenie instrukcji
	sbis	PINA,7		; badanie bitu o numerze 7 w porcie A
	rjmp	Main_17		; warunkowe opuszczenie instrukcji
	rjmp	Main_0		; powrt do ptli gwnej
Main_10	:			;
	ldi	acc,0b11111110	; PORTB := 0B11111110 ;
	out	PortB,acc	;
	rjmp	Main_0		;
Main_11	:			;
	ldi	acc,0b11111101	; PORTB := 0B11111101 ;
	out	PortB,acc	;
	rjmp	Main_0		;
Main_12	:			;
	ldi	acc,0B11111011	; PORTB := 0B11111011 ;
	out	PortB,acc	;
	rjmp	Main_0		;
Main_13	:			;
	ldi	acc,0B11110111	; PORTB := 0B11110111 ;
	out	PortB,acc	;
	rjmp	Main_0		;
Main_14	:			;
	ldi	acc,0B11101111	; PORTB := 0B11101111 ;
	out	PortB,acc	;
	rjmp	Main_0		;
Main_15	:			;
	ldi	acc,0B11011111	; PORTB := 0B11011111 ;
	out	PortB,acc	;
	rjmp	Main_0		;
Main_16	:			;
	ldi	acc,0B10111111	; PORTB := 0B10111111 ;
	out	PortB,acc	;
	rjmp	Main_0		;
Main_17	:			;
	ldi	acc,0B01111111	; PORTB := 0B01111111 ;
	out	PortB,acc	;
	rjmp	Main_0		;
;---------------------------------------------------------------
.exit
